'use strict';

Object.defineProperty(exports, '__esModule', {
	value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var Logger = (function () {
	function Logger(options) {
		_classCallCheck(this, Logger);

		this._options = options;
		this._count = 0;
		this._stack = {};
	}

	_createClass(Logger, [{
		key: 'log',
		value: function log(message, func) {
			var result;

			if (process.env.NODE_ENV !== 'production' && this._options.debug) {
				this._start(message);
				result = func();
				this._stop(message);
				return result;
			}
			return func();
		}
	}, {
		key: '_start',
		value: function _start(message) {
			var indentation = this._indent();
			var now = new Date();

			this._stack[message] = now;

			console.log('[' + now.toISOString() + '] ' + indentation + 'Starting ' + message + '...');
		}
	}, {
		key: '_stop',
		value: function _stop(message) {
			var indentation = this._unindent();
			var now = new Date();
			var elapsed = now - this._stack[message];

			console.log('[' + now.toISOString() + '] ' + indentation + 'Finished ' + message + ' after ' + elapsed + ' ms');
		}
	}, {
		key: '_indent',
		value: function _indent() {
			return Array(++this._count).join('  ');
		}
	}, {
		key: '_unindent',
		value: function _unindent() {
			return Array(this._count--).join('  ');
		}
	}]);

	return Logger;
})();

exports['default'] = Logger;
module.exports = exports['default'];