'use strict';

Object.defineProperty(exports, '__esModule', {
	value: true
});

var _factories;

exports['default'] = createMapping;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _utils = require('./utils');

var _createSimpleMappingFactory = require('./createSimpleMappingFactory');

var _createSimpleMappingFactory2 = _interopRequireDefault(_createSimpleMappingFactory);

var _createSingletonMappingFactory = require('./createSingletonMappingFactory');

var _createSingletonMappingFactory2 = _interopRequireDefault(_createSingletonMappingFactory);

var _createPropertyMapper = require('./createPropertyMapper');

var _createPropertyMapper2 = _interopRequireDefault(_createPropertyMapper);

var _options = require('./options');

var factories = (_factories = {}, _defineProperty(_factories, (0, _utils.generateMask)([_options.VALUE]), (0, _createSimpleMappingFactory2['default'])(_utils.identity)), _defineProperty(_factories, (0, _utils.generateMask)([_options.FUNCTION]), (0, _createSimpleMappingFactory2['default'])(_utils.partial)), _defineProperty(_factories, (0, _utils.generateMask)([_options.CONSTRUCTOR]), (0, _createSimpleMappingFactory2['default'])(_utils.instanciate)), _defineProperty(_factories, (0, _utils.generateMask)([_options.PROVIDER]), (0, _createSimpleMappingFactory2['default'])(_utils.invoke)), _defineProperty(_factories, (0, _utils.generateMask)([_options.TRANSIENT, _options.SINGLETON, _options.PROVIDER]), (0, _createSingletonMappingFactory2['default'])(_utils.invoke, true)), _defineProperty(_factories, (0, _utils.generateMask)([_options.TRANSIENT, _options.CONSTRUCTOR, _options.SINGLETON]), (0, _createSingletonMappingFactory2['default'])(_utils.instanciate, true)), _defineProperty(_factories, (0, _utils.generateMask)([_options.LAZY, _options.SINGLETON, _options.PROVIDER]), (0, _createSingletonMappingFactory2['default'])(_utils.invoke)), _defineProperty(_factories, (0, _utils.generateMask)([_options.LAZY, _options.SINGLETON, _options.CONSTRUCTOR]), (0, _createSingletonMappingFactory2['default'])(_utils.instanciate)), _defineProperty(_factories, (0, _utils.generateMask)([_options.EAGER, _options.SINGLETON, _options.PROVIDER]), (0, _createSingletonMappingFactory2['default'])(_utils.invoke)), _defineProperty(_factories, (0, _utils.generateMask)([_options.EAGER, _options.SINGLETON, _options.CONSTRUCTOR]), (0, _createSingletonMappingFactory2['default'])(_utils.instanciate)), _factories);

// aliases
factories[(0, _utils.generateMask)([_options.INSTANCE])] = factories[(0, _utils.generateMask)([_options.VALUE])];

function createMapping(type, value, resolveDeps, releaseDeps) {
	if (!(type in factories)) {
		throw new Error('Invalid flags combination. See documentation for valid flags combinations.');
	}
	return (0, _createPropertyMapper2['default'])(factories[type], value, resolveDeps, releaseDeps);
}

module.exports = exports['default'];